function map = sky_cof_map(I, grid_x, grid_y, patch_size, Y_hat)

% parameters
map = zeros(size(I(:,:,1)));
wei = zeros(size(I(:,:,1)));
num_patches = numel(grid_x);
 % for all patches
for ii=1:num_patches
    
    x_lo = grid_x(ii);
    x_hi = grid_x(ii) + patch_size - 1;
    y_lo = grid_y(ii);
    y_hi = grid_y(ii) + patch_size - 1;
    
    map(y_lo:y_hi,x_lo:x_hi,1) = map(y_lo:y_hi,x_lo:x_hi,1) + Y_hat(ii);
    wei(y_lo:y_hi,x_lo:x_hi,1) = wei(y_lo:y_hi,x_lo:x_hi,1) + 1;
end

map = map./(wei + double(wei==0));

end