function label_arr = sp_find_label_grid(grid_x, grid_y,mask, patch_size)

% parameters

 
 
num_patches = numel(grid_x);

label_arr = zeros(num_patches, 1);

boundary = double(conv2(double(edge(mask,'sobel')),ones(7),'same') > 0.5);
% for all patches
for ii=1:num_patches
    r = patch_size/2;

    cx = round(grid_x(ii) + r - 0.5);
    cy = round(grid_y(ii) + r - 0.5);
    if boundary(cy,cx) == 1;
        label_arr(ii) = 0;
    else
        if 0 == mask(cy,cx)
            label_arr(ii) = -1;
        else
            label_arr(ii) = 1;
        end
    end
 

    
end